package com.semesterproject.socialmine;


import android.app.Service;
import android.content.Intent;
import android.os.IBinder;
import android.util.Log;

public class UpdaterService extends Service {

	private static final String TAG = UpdaterService.class.getSimpleName(); // Define this class as variable for logging
	private Updater updater;
	public boolean isRunning = false;
	
	@Override
	public IBinder onBind(Intent intent) {
		return null;
	}

	@Override
	public void onCreate() {
		// TODO Auto-generated method stub
		super.onCreate();
		
		updater = new Updater();
		
		Log.d(TAG, "onCreate'd");
	}

	@Override
	public synchronized void onStart(Intent intent, int startId) {
		// TODO Auto-generated method stub
		super.onStart(intent, startId);
		
		// Starting the Service is only possible if it's not already running
		
		if (!this.isRunning)	{
			updater.start();
			this.isRunning = true;
			Log.d(TAG, "onStart'd");

		}
		

	}

	@Override
	public synchronized void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();

		// Stopping Service is only possible if it's not already stopped

		
		if (this.isRunning)	{
			updater.interrupt();
			this.isRunning = true;
			Log.d(TAG, "onDestroy'd");
		}
		
		updater = null;			// for garbage collection
		
		

	}
	
	
	//////// Private-Updater Thread /////////
	
	class Updater extends Thread	{

		static final long DELAY = 3000;		// 3s periodic updates
		private boolean isRunning = true;
		
		
		// Class Constructor //
		public Updater()	{		
			super("Updater");
		}
		
		@Override
		public void run() {

			while (isRunning) {
				try {
					// Do something
					Log.d(TAG, "Updater run'ing");
					
					
					
					// Sleep
					Thread.sleep(DELAY);
				} catch (InterruptedException e) {
					// Interrupted
					isRunning = false;
				}
			}	// endless while-loop
		}
		
		}
	
		public boolean isRunning()	{
			return this.isRunning;
		}
	
	
	
	
}